# coding: utf-8

"""
    3blades API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class NotificationSettings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'user': 'str',
        'entity': 'str',
        'enabled': 'bool',
        'emails_enabled': 'bool',
        'email_address': 'str'
    }

    attribute_map = {
        'id': 'id',
        'user': 'user',
        'entity': 'entity',
        'enabled': 'enabled',
        'emails_enabled': 'emails_enabled',
        'email_address': 'email_address'
    }

    def __init__(self, id=None, user=None, entity=None, enabled=None, emails_enabled=None, email_address=None):
        """
        NotificationSettings - a model defined in Swagger
        """

        self._id = None
        self._user = None
        self._entity = None
        self._enabled = None
        self._emails_enabled = None
        self._email_address = None

        if id is not None:
          self.id = id
        if user is not None:
          self.user = user
        if entity is not None:
          self.entity = entity
        self.enabled = enabled
        self.emails_enabled = emails_enabled
        if email_address is not None:
          self.email_address = email_address

    @property
    def id(self):
        """
        Gets the id of this NotificationSettings.
        Notification unique identifier expressed as a UUID

        :return: The id of this NotificationSettings.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this NotificationSettings.
        Notification unique identifier expressed as a UUID

        :param id: The id of this NotificationSettings.
        :type: str
        """

        self._id = id

    @property
    def user(self):
        """
        Gets the user of this NotificationSettings.
        User the notification settings is for.

        :return: The user of this NotificationSettings.
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """
        Sets the user of this NotificationSettings.
        User the notification settings is for.

        :param user: The user of this NotificationSettings.
        :type: str
        """

        self._user = user

    @property
    def entity(self):
        """
        Gets the entity of this NotificationSettings.
        The entity type that the settings pertain to.

        :return: The entity of this NotificationSettings.
        :rtype: str
        """
        return self._entity

    @entity.setter
    def entity(self, entity):
        """
        Sets the entity of this NotificationSettings.
        The entity type that the settings pertain to.

        :param entity: The entity of this NotificationSettings.
        :type: str
        """
        allowed_values = ["global", "billing"]
        if entity not in allowed_values:
            raise ValueError(
                "Invalid value for `entity` ({0}), must be one of {1}"
                .format(entity, allowed_values)
            )

        self._entity = entity

    @property
    def enabled(self):
        """
        Gets the enabled of this NotificationSettings.
        Turn notifications on or off entirely.

        :return: The enabled of this NotificationSettings.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """
        Sets the enabled of this NotificationSettings.
        Turn notifications on or off entirely.

        :param enabled: The enabled of this NotificationSettings.
        :type: bool
        """
        if enabled is None:
            raise ValueError("Invalid value for `enabled`, must not be `None`")

        self._enabled = enabled

    @property
    def emails_enabled(self):
        """
        Gets the emails_enabled of this NotificationSettings.
        Turn emails on or off.

        :return: The emails_enabled of this NotificationSettings.
        :rtype: bool
        """
        return self._emails_enabled

    @emails_enabled.setter
    def emails_enabled(self, emails_enabled):
        """
        Sets the emails_enabled of this NotificationSettings.
        Turn emails on or off.

        :param emails_enabled: The emails_enabled of this NotificationSettings.
        :type: bool
        """
        if emails_enabled is None:
            raise ValueError("Invalid value for `emails_enabled`, must not be `None`")

        self._emails_enabled = emails_enabled

    @property
    def email_address(self):
        """
        Gets the email_address of this NotificationSettings.
        Email address to send notifications.

        :return: The email_address of this NotificationSettings.
        :rtype: str
        """
        return self._email_address

    @email_address.setter
    def email_address(self, email_address):
        """
        Sets the email_address of this NotificationSettings.
        Email address to send notifications.

        :param email_address: The email_address of this NotificationSettings.
        :type: str
        """

        self._email_address = email_address

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, NotificationSettings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
